
numaddPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);

var numadd = {
	
	save: function() {
		
		// Get the preference for the usermaps.txt location
		var prefs = new PrefsWrapper1("extensions.numadd.") ;
				
		if (prefs.getCharPref("usermapsLocation") == "none") {
			numaddPrompts.alert(null, "numADD", "Please set your userlevels.txt position\n" +
			      "by right-clicking the numADD button.") ;
			return ;
		}
		
		// Check the active tab is an N map
		if (content.document.location.hostname != "www.nmaps.net"
				|| content.document.title.indexOf("N Map") == -1) {
				
			numaddPrompts.alert(null, "numADD", "This is not an N map.") ;
			return ;
		}
		
		// Find the title and ask for a category
		var titleEndingPoint = content.document.title.indexOf(" - N Map") ;
		var title = content.document.title.substring(0, titleEndingPoint) ;
		
		var category = {value: ""} ;
		var check = {value: false} ; // no checkbox, but still needed >:-|
		if (!numaddPrompts.prompt(null, "numADD", "Enter a category for the map \"" + title + "\":",
		                           category, null, check)) return ;
		
		// Open the userlevels file
		var file = FileIO.open(prefs.getCharPref("usermapsLocation")) ;
		if (!file) {
			numaddPrompts.alert(null, "numADD", "Cannot find userlevels.txt.\n" +
			      "Reset it by using the \"Change userlevels.txt position\" option.") ;
			return ;
		}
		
		// Start the HTTP request for the map data
		var dataURL = content.document.location + "/data" ;
		var req = new XMLHttpRequest() ;
		req.open("GET", dataURL, true) ;
		req.onreadystatechange = function(e) {
			if (req.readyState == 4) {
				if (req.status == 200) {
					// Now we can do the userlevels.txt modifying
					var mapText = req.responseText ;
					
					// hashes in the category will mess up userlevels.txt
					// Replace it with "no." for "number", since that's the most likely
					// use for a hash in a category name
					category.value = category.value.replace("#", "no.") ; 
					// Add the category to the map text
					mapText = mapText.replace("##", "#" + category.value + "#") ;
					
					// Write to the file
					var success = FileIO.write(file, "\r\n\r\n" + mapText, 'a') ;
					if (!success) {
						numaddPrompts.alert(null, "numADD", "Cannot find userlevels.txt.\n" +
						      "Reset it by using the \"Change userlevels.txt position\" option.") ;
						return ;
					}
					
					// And we're done!
					numaddPrompts.alert(null, "numADD", "Level added.") ;
				}
				else numaddPrompts.alert(null, "numADD", "Error " + e.target.status + " occurred while receiving the map data.") ;
			}
		} ;
		req.send(null) ;
	},
	
	repref: function() {
		
		var prefs = new PrefsWrapper1("extensions.numadd.") ;
		
		const nsIFilePicker = Components.interfaces.nsIFilePicker ;

		var fp = Components.classes["@mozilla.org/filepicker;1"]
					.createInstance(nsIFilePicker) ;
		fp.init(window, "Choose userlevels.txt:", nsIFilePicker.modeLoad) ;
		fp.appendFilters(nsIFilePicker.filterText) ;
		
		var rv = fp.show() ;
		if (rv == nsIFilePicker.returnOK) {
//			alert("Set it to:" + fp.file.path) ;
			prefs.setCharPref("usermapsLocation", fp.file.path) ;
		} else return ;
		
		numaddPrompts.alert(null, "numADD", "userlevels.txt position set.") ;
	},
	
	reprefExe: function() {
		
		var prefs = new PrefsWrapper1("extensions.numadd.") ;
		
		const nsIFilePicker = Components.interfaces.nsIFilePicker ;

		var fp = Components.classes["@mozilla.org/filepicker;1"]
					.createInstance(nsIFilePicker) ;
		fp.init(window, "Choose n_v14.exe:", nsIFilePicker.modeLoad) ;
		fp.appendFilters(nsIFilePicker.filterApps) ;
		
		var rv = fp.show() ;
		if (rv == nsIFilePicker.returnOK) {
//			alert("Set it to:" + fp.file.path) ;
			prefs.setCharPref("nLocation", fp.file.path) ;
		} else return ;
		
		numaddPrompts.alert(null, "numADD", "N executable position set.") ;
	},
	
	loadN: function() {
		
		// Get the preference for the usermaps.txt location
		var prefs = new PrefsWrapper1("extensions.numadd.") ;
		
//		alert("Loading N from:" + prefs.getCharPref("usermapsLocation")) ;
		
		if (prefs.getCharPref("nLocation") == "none") {
			numaddPrompts.alert(null, "numADD", "Please set your N executable position.") ;
			return ;
		}
		
		var file = Components.classes["@mozilla.org/file/local;1"]
					                  .createInstance(Components.interfaces.nsILocalFile) ;
		file.initWithPath(prefs.getCharPref("nLocation")) ;
		file.launch() ;
	},
	
	loadNUMA: function() {
		gBrowser.addTab("http://nmaps.net/") ;
	}
} ;